#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

void debug_exit(int rc, int lineno)
{
  if (rc == 0) exit(0);
  fprintf(stderr, "Exiting with code %d at line %d\n", rc, lineno);
  (void)fgetc(stdin);
  exit(rc);
}
#define exit(n) debug_exit(n, __LINE__)

int main(int argc, char **argv) {
  char command[4096], outfilename[2048];
  char *s;
  int l, rc;

// TO DO:  add -o outfilename before the -d option.
// strip the .gpg
// remove the .gpg file after decrypting

  l = strlen(argv[1]);
  if ((l <= 4) || (l > 2047)) exit(1); // and print error message?
  strcpy(outfilename, argv[1]);
  s = outfilename + l - strlen(".gpg");
  if (stricmp(s, ".gpg") != 0) exit(1); // ditto
  *s = '\0';

  sprintf(command, "gpg --keyring \"C:\\Documents and Settings"
                   "\\gtoal\\Application Data\\gnupg\\pubring.gpg\""
                   " --secret-keyring "
                   "\"C:\\Documents and Settings\\gtoal\\Application Data"
                   "\\gnupg\\secring.gpg\" -u gtoal@utpa.edu "
                   "-o \"%s\" -d \"%s\"",
          outfilename, argv[1]);

  fprintf(stderr, "Executing %s\n", command);
  fflush(stderr);

  rc = system(command);

  if (rc == 0) rc = remove(argv[1]);

  exit(rc); return(rc);
}
